// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include <thread>

#include "BinaryPrivateSemaphore.hpp"
#include "Fiber.hpp"
#include "emper.hpp"

void emperTest() {
	BinaryPrivateSemaphore bpsTest;
	BinaryPrivateSemaphore bpsSignalledFromAnywhere;

	Fiber* fiberWaitingForBps = Fiber::from([&] {
		bpsSignalledFromAnywhere.wait();

		bpsTest.signal();
	});

	async(fiberWaitingForBps);

	// TODO: Use std::jthread once EMPER uses C++20.
	std::thread signallingThread([&] { bpsSignalledFromAnywhere.signalFromAnywhere(); });

	bpsTest.wait();

	// TODO: Remove this once we use std::jthread when EMPER uses C++20.
	signallingThread.join();
}
