// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include <cstdlib>
#include <iostream>

#include "Fiber.hpp"
#include "Runtime.hpp"
#include "emper-common.h"

void emperTest() __attribute__((weak));

static void invokeTest() {
	emperTest();

	exit(EXIT_SUCCESS);
}

auto main(UNUSED_ARG int argc, UNUSED_ARG char* argv[]) -> int {
	if (!&emperTest) {
		std::cerr << "ERROR: The emperTest() method is not defined.";
		return EXIT_FAILURE;
	}

	Runtime runtime;

	Fiber* alphaFiber = Fiber::from(&invokeTest);

	runtime.scheduleFromAnywhere(*alphaFiber);

	runtime.waitUntilFinished();

	return EXIT_FAILURE;
}
